Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.cpp	(revision 54)
@@ -81,4 +81,8 @@
 , m_bNoBackPredFlag               ( false )
 , m_uiTLayer                      ( 0 )
+#if SVC_EXTENSION
+, m_layerId                     ( 0 )
+, m_pcBaseColPic                  ( NULL )
+#endif
 , m_bTLayerSwitchingFlag          ( false )
 , m_sliceMode                   ( 0 )
@@ -136,6 +140,13 @@
 
 
+#if SET_SLICE_LAYER_ID
+Void TComSlice::initSlice( UInt layerId )
+#else
 Void TComSlice::initSlice()
-{
+#endif
+{
+#if SET_SLICE_LAYER_ID
+  m_layerId = layerId;
+#endif
   m_aiNumRefIdx[0]      = 0;
   m_aiNumRefIdx[1]      = 0;
@@ -344,5 +355,11 @@
 Void TComSlice::setRefPicList( TComList<TComPic*>& rcListPic )
 {
+#if REF_IDX_FRAMEWORK
+  if( m_eSliceType == I_SLICE || ( getSPS()->getLayerId() && 
+      (getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA) &&
+      (getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA) ) )
+#else
   if (m_eSliceType == I_SLICE)
+#endif
   {
     ::memset( m_apcRefPicList, 0, sizeof (m_apcRefPicList));
@@ -1261,4 +1278,7 @@
 , m_vuiParametersPresentFlag  (false)
 , m_vuiParameters             ()
+#if SVC_EXTENSION
+, m_layerId(0)
+#endif
 {
   for ( Int i = 0; i < MAX_TLAYER; i++ )
@@ -1926,5 +1946,9 @@
 //! activate a PPS and depending on isIDR parameter also SPS and VPS
 //! \returns true, if activation is successful
+#if SVC_EXTENSION
+Bool ParameterSetManager::activatePPS(Int ppsId, Bool isIDR, UInt layerId)
+#else
 Bool ParameterSetManager::activatePPS(Int ppsId, Bool isIDR)
+#endif
 {
   TComPPS *pps = m_ppsMap.getPS(ppsId);
@@ -1932,5 +1956,9 @@
   {
     Int spsId = pps->getSPSId();
+#if SVC_EXTENSION
+    if (!isIDR && (spsId != layerId ))
+#else
     if (!isIDR && (spsId != m_activeSPSId))
+#endif
     {
       printf("Warning: tried to activate PPS referring to a inactive SPS at non-IDR.");
@@ -2001,3 +2029,151 @@
 }
 #endif
+
+#if SVC_EXTENSION
+#if AVC_SYNTAX
+Void TComSlice::initBaseLayerRPL( TComSlice *pcSlice )
+{
+// Assumed that RPL of the base layer is same to the EL, otherwise this information should be also dumped and read from the metadata file
+  setPOC( pcSlice->getPOC() );
+  if( pcSlice->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA )
+  {
+    setSliceType( I_SLICE );
+  }
+  else
+  {
+    setSliceType( pcSlice->getSliceType() );
+  }
+
+  if( this->isIntra() )
+  {
+    return;
+  }
+
+  //initialize reference POC of BL
+  for( Int iRefPicList = 0; iRefPicList < 2; iRefPicList++ )
+  {
+    RefPicList eRefPicList = RefPicList( iRefPicList );
+
+    assert( pcSlice->getNumRefIdx( eRefPicList) > 0 );
+    setNumRefIdx( eRefPicList, pcSlice->getNumRefIdx( eRefPicList ) - 1 );
+    assert( getNumRefIdx( eRefPicList) <= MAX_NUM_REF);
+
+    for(Int refIdx = 0; refIdx < getNumRefIdx( eRefPicList ); refIdx++) 
+    {
+      setRefPOC( pcSlice->getRefPic( eRefPicList, refIdx )->getPOC(), eRefPicList, refIdx );
+      setRefPic( pcSlice->getRefPic( eRefPicList, refIdx ), eRefPicList, refIdx );
+      /*
+      // should be set if the base layer has its own instance of the reference picture lists, currently EL RPL is reused.
+      getRefPic( eRefPicList, refIdx )->setLayerId( 0 );
+      getRefPic( eRefPicList, refIdx )->setIsLongTerm( pcSlice->getRefPic( eRefPicList, refIdx )->getIsLongTerm() );
+      getRefPic( eRefPicList, refIdx )->setIsUsedAsLongTerm( pcSlice->getRefPic( eRefPicList, refIdx )->getIsUsedAsLongTerm() );
+      */
+
+    }
+  }  
+  return;
+}
+#endif
+
+Void TComSlice::setBaseColPic(  TComList<TComPic*>& rcListPic, UInt layerID )
+{  
+  if (layerID == 0)
+  {
+    m_pcBaseColPic = NULL;
+    return;
+  }        
+  setBaseColPic(xGetRefPic(rcListPic, getPOC())); 
+}
+#endif 
+
+#if REF_IDX_FRAMEWORK
+Void TComSlice::addRefPicList( TComPic **pIlpPicList, Int iRefPicNum, Int iInsertOffset )
+{
+  if(getSPS()->getLayerId() && m_eSliceType != I_SLICE)
+  {
+#if REF_IDX_MFM
+    assert(iRefPicNum == 1);
+    if( getPOC() != 0 )
+    { 
+      pIlpPicList[0]->copyUpsampledMvField(getBaseColPic());
+    }
+#endif
+    //add to list 0;
+    Int iOffset;
+    m_aiNumRefIdx[REF_PIC_LIST_0] += iInsertOffset;
+    iOffset = m_aiNumRefIdx[REF_PIC_LIST_0];
+    for (Int i=0; i<iRefPicNum; i++)
+    {
+      pIlpPicList[i]->setIsLongTerm(1);  //mark ilp as long-term reference
+      pIlpPicList[i]->setIsUsedAsLongTerm(1);  //mark ilp as long-term reference
+      m_apcRefPicList[REF_PIC_LIST_0][iOffset + i] = pIlpPicList[i]; 
+      m_aiNumRefIdx[REF_PIC_LIST_0]++;
+      //m_aiNumRefIdx[REF_PIC_LIST_C]++;
+    }
+    if(m_eSliceType == B_SLICE)
+    {
+      m_aiNumRefIdx[REF_PIC_LIST_1] += iInsertOffset;
+      iOffset = m_aiNumRefIdx[REF_PIC_LIST_1];
+      for (Int i=0; i<iRefPicNum; i++)
+      {
+        pIlpPicList[i]->setIsLongTerm(1);  //mark ilp as long-term reference
+        pIlpPicList[i]->setIsUsedAsLongTerm(1);  //mark ilp as long-term reference
+        m_apcRefPicList[REF_PIC_LIST_1][iOffset + i] = pIlpPicList[i]; 
+        m_aiNumRefIdx[REF_PIC_LIST_1]++;
+        //m_aiNumRefIdx[REF_PIC_LIST_C]++;
+      }
+    }
+  }
+}
+
+#if REF_IDX_MFM
+Void TComSlice::setRefPOCListILP( TComPic** ilpPic, TComPic *pcRefPicBL )
+{
+  //set reference picture POC of each ILP reference 
+  Int thePoc = ilpPic[0]->getPOC(); 
+  assert(thePoc >= 0); 
+  assert(thePoc == pcRefPicBL->getPOC());
+
+#if REUSE_MVSCALE || REUSE_BLKMAPPING
+  ilpPic[0]->getSlice(0)->setBaseColPic( pcRefPicBL );
+#endif
+
+  //initialize reference POC of ILP 
+  for(Int refIdx = 0; refIdx < MAX_NUM_REF; refIdx++) 
+  { 
+    ilpPic[0]->getSlice(0)->setRefPOC(0, REF_PIC_LIST_0, refIdx); 
+    ilpPic[0]->getSlice(0)->setRefPOC(0, REF_PIC_LIST_1, refIdx); 
+
+    ilpPic[0]->getSlice(0)->setRefPic(NULL, REF_PIC_LIST_0, refIdx); 
+    ilpPic[0]->getSlice(0)->setRefPic(NULL, REF_PIC_LIST_1, refIdx); 
+  }
+
+  //set reference POC of ILP 
+  ilpPic[0]->getSlice(0)->setNumRefIdx(REF_PIC_LIST_0, pcRefPicBL->getSlice(0)->getNumRefIdx(REF_PIC_LIST_0));
+  assert(ilpPic[0]->getSlice(0)->getNumRefIdx(REF_PIC_LIST_0) <= MAX_NUM_REF); 
+  ilpPic[0]->getSlice(0)->setNumRefIdx(REF_PIC_LIST_1, pcRefPicBL->getSlice(0)->getNumRefIdx(REF_PIC_LIST_1));
+  assert(ilpPic[0]->getSlice(0)->getNumRefIdx(REF_PIC_LIST_1) <= MAX_NUM_REF);
+
+  for(Int refIdx = 0; refIdx < pcRefPicBL->getSlice(0)->getNumRefIdx(REF_PIC_LIST_0); refIdx++) 
+  {
+    ilpPic[0]->getSlice(0)->setRefPOC(pcRefPicBL->getSlice(0)->getRefPOC(REF_PIC_LIST_0, refIdx), REF_PIC_LIST_0, refIdx); 
+  }
+  for(Int refIdx = 0; refIdx < pcRefPicBL->getSlice(0)->getNumRefIdx(REF_PIC_LIST_1); refIdx++) 
+  {
+    ilpPic[0]->getSlice(0)->setRefPOC(pcRefPicBL->getSlice(0)->getRefPOC(REF_PIC_LIST_1, refIdx), REF_PIC_LIST_1, refIdx);
+  }
+  for(Int refIdx = 0; refIdx < pcRefPicBL->getSlice(0)->getNumRefIdx(REF_PIC_LIST_0); refIdx++) 
+  {
+    ilpPic[0]->getSlice(0)->setRefPic(pcRefPicBL->getSlice(0)->getRefPic(REF_PIC_LIST_0, refIdx), REF_PIC_LIST_0, refIdx); 
+  }
+  for(Int refIdx = 0; refIdx < pcRefPicBL->getSlice(0)->getNumRefIdx(REF_PIC_LIST_1); refIdx++) 
+  {
+    ilpPic[0]->getSlice(0)->setRefPic(pcRefPicBL->getSlice(0)->getRefPic(REF_PIC_LIST_1, refIdx), REF_PIC_LIST_1, refIdx); 
+  }
+  return;
+}
+#endif
+
+
+#endif
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.h	(revision 54)
@@ -51,4 +51,8 @@
 class TComPic;
 class TComTrQuant;
+
+#if SVC_EXTENSION
+class TComPicYuv;
+#endif
 // ====================================================================================================================
 // Constants
@@ -850,4 +854,11 @@
   static const Int   m_winUnitY[MAX_CHROMA_FORMAT_IDC+1];
   TComPTL     m_pcPTL;
+
+#if SVC_EXTENSION
+  UInt m_layerId;
+#endif
+#if REF_IDX_MFM
+  Bool m_bMFMEnabledFlag;
+#endif
 public:
   TComSPS();
@@ -976,4 +987,13 @@
 
   TComPTL* getPTL()     { return &m_pcPTL; }
+
+#if SVC_EXTENSION
+  Void     setLayerId(UInt layerId) { m_layerId = layerId; }
+  UInt     getLayerId() { return m_layerId; }
+#endif
+#if REF_IDX_MFM
+  Void     setMFMEnabledFlag(Bool flag) {m_bMFMEnabledFlag = flag;}
+  Bool     getMFMEnabledFlag()          {return m_bMFMEnabledFlag;}
+#endif
 };
 
@@ -1283,4 +1303,9 @@
   Bool        m_bNoBackPredFlag;
   UInt        m_uiTLayer;
+#if SVC_EXTENSION
+  UInt        m_layerId;
+  TComPic*    m_pcBaseColPic;
+  TComPicYuv* m_pcFullPelBaseRec;
+#endif 
   Bool        m_bTLayerSwitchingFlag;
 
@@ -1319,5 +1344,9 @@
   TComSlice();
   virtual ~TComSlice(); 
+#if SET_SLICE_LAYER_ID
+  Void      initSlice       ( UInt layerId );
+#else
   Void      initSlice       ();
+#endif
 
   Void      setVPS          ( TComVPS* pcVPS ) { m_pcVPS = pcVPS; }
@@ -1417,4 +1446,24 @@
   Void      setDepth            ( Int iDepth )                  { m_iDepth            = iDepth; }
   
+#if SVC_EXTENSION  
+  Void      setBaseColPic       ( TComPic* p)                   { m_pcBaseColPic = p; }
+  Void      setBaseColPic       ( TComList<TComPic*>& rcListPic , UInt layerID );
+  TComPic*  getBaseColPic       ()  { return m_pcBaseColPic; }
+
+  Void      setLayerId (UInt layerId) { m_layerId = layerId; }
+  UInt      getLayerId ()               { return m_layerId; }
+
+  Void        setFullPelBaseRec   ( TComPicYuv* p) { m_pcFullPelBaseRec = p; }
+  TComPicYuv* getFullPelBaseRec   ()  { return  m_pcFullPelBaseRec;  }
+
+#if AVC_SYNTAX
+  Void      initBaseLayerRPL( TComSlice *pcSlice );
+#endif
+#endif
+
+#if REF_IDX_MFM
+  Void      setRefPOCListILP(TComPic** ilpPic, TComPic *pcRefPicBL);
+#endif
+
   Void      setRefPicList       ( TComList<TComPic*>& rcListPic );
   Void      setRefPOCList       ();
@@ -1536,5 +1585,7 @@
   Void      setEnableTMVPFlag     ( Bool   b )    { m_enableTMVPFlag = b; }
   Bool      getEnableTMVPFlag     ()              { return m_enableTMVPFlag;}
-
+#if REF_IDX_FRAMEWORK
+  Void      addRefPicList( TComPic **pIlpPicList, Int iRefPicNum, Int iInsertOffset=0 );
+#endif
 protected:
   TComPic*  xGetRefPic  (TComList<TComPic*>& rcListPic,
@@ -1625,5 +1676,9 @@
   //! activate a PPS and depending on isIDR parameter also SPS and VPS
   //! \returns true, if activation is successful
+#if SVC_EXTENSION
+  Bool activatePPS(Int ppsId, Bool isIDR, UInt layerId);
+#else
   Bool activatePPS(Int ppsId, Bool isIDR);
+#endif
 
   TComVPS* getActiveVPS(){ return m_vpsMap.getPS(m_activeVPSId); };
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComTrQuant.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComTrQuant.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComTrQuant.cpp	(revision 54)
@@ -1236,4 +1236,10 @@
     uiMode = pcCU->getLumaIntraDir( uiAbsPartIdx );
   }
+#if INTRA_BL_DST4x4
+  else if(eTType == TEXT_LUMA && pcCU->isIntraBL(uiAbsPartIdx) )
+  {
+    uiMode = DC_IDX; //Using DST
+  }
+#endif
   else
   {
@@ -1309,5 +1315,16 @@
     Int scalingListType = (pcCU->isIntra(uiAbsPartIdx) ? 0 : 3) + g_eTTable[(Int)eTxt];
     assert(scalingListType < 6);
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+    if(pcCU->isIntraBL(uiAbsPartIdx) && eTxt == TEXT_LUMA)
+    {
+      invtransformNxN( pcCU->getCUTransquantBypass(uiAbsPartIdx), eTxt, DC_IDX, pResi, uiStride, rpcCoeff, uiWidth, uiHeight, scalingListType, pcCU->getTransformSkip(uiAbsPartIdx, eTxt) );
+    }
+    else
+    {
+      invtransformNxN( pcCU->getCUTransquantBypass(uiAbsPartIdx), eTxt, REG_DCT, pResi, uiStride, rpcCoeff, uiWidth, uiHeight, scalingListType, pcCU->getTransformSkip(uiAbsPartIdx, eTxt) );
+    }
+#else
     invtransformNxN( pcCU->getCUTransquantBypass(uiAbsPartIdx), eTxt, REG_DCT, pResi, uiStride, rpcCoeff, uiWidth, uiHeight, scalingListType, pcCU->getTransformSkip(uiAbsPartIdx, eTxt) );
+#endif
   }
   else
@@ -1803,5 +1820,9 @@
   Int     ui16CtxCbf          = 0;
   Int     iBestLastIdxP1      = 0;
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+  if( (!pcCU->isIntra( uiAbsPartIdx ) || pcCU->isIntraBL( uiAbsPartIdx )) && eTType == TEXT_LUMA && pcCU->getTransformIdx( uiAbsPartIdx ) == 0 )
+#else
   if( !pcCU->isIntra( uiAbsPartIdx ) && eTType == TEXT_LUMA && pcCU->getTransformIdx( uiAbsPartIdx ) == 0 )
+#endif
   {
     ui16CtxCbf   = 0;
